/*
 * Copyright (C) 2000 Robert Fitzsimons
 */

#ifndef _ujvm_unicode_h
#define _ujvm_unicode_h

#include "basetypes.h"
#include "datatypes.h"

struct Unicode {
	kuint hash;
	kuint length;
	kuint16 array[0];
};

Unicode* unicode_put_array(kuint16* array, kuint array_length);
Unicode* unicode_put_utf8(kuint8* utf8, kuint utf8_length);
Unicode* unicode_put_ascii(kuint8* ascii);

Unicode* unicode_get(kuint hash);

kuint unicode_hash_array(kuint16* array, kuint array_length);
kuint unicode_hash_utf8(kuint8* utf8, kuint utf8_length, kuint* new_length);

kuint8* unicode_to_utf8(Unicode* unicode, kuint* utf8_length);
kuint8* unicode_to_ascii(Unicode* unicode);

#endif /* _ujvm_unicode_h */

